local frmRFLRollTracker = nil;
RFLLootRollIdxByIndex = nil;
RFLLootRollIdxByValue = nil;
RFLLootRolls = nil;
DisplayedRTID = 1;


function RollForLoot:BuildRollTrackerFrame()
	if(frmRFLRollTracker == nil) then
		frmRFLRollTracker = CreateFrame("Frame", "frmRFLRollTracker", UIParent, "BasicFrameTemplate");

		-- Build Roll Tracker Frame
		frmRFLRollTracker:SetWidth(500);
		frmRFLRollTracker:SetHeight(300);
		frmRFLRollTracker:SetFrameStrata("DIALOG");
		frmRFLRollTracker:SetPoint("CENTER",0,0)
		frmRFLRollTracker:SetMovable(true)
		frmRFLRollTracker:EnableMouse(true)
		frmRFLRollTracker:RegisterForDrag("LeftButton")
		frmRFLRollTracker:SetScript("OnDragStart", frmRFLRollTracker.StartMoving)
		frmRFLRollTracker:SetScript("OnDragStop", frmRFLRollTracker.StopMovingOrSizing)
		frmRFLRollTracker:SetScript("OnUpdate", function(self, elapsed) RollForLoot:RefreshRollTracker(self,elapsed) end)
		
		-- Build Roll Tracker Title
		local frmRFLRTTitleText = frmRFLRollTracker:CreateFontString("$parentTitle", "Overlay", "GameFontNormal")
		frmRFLRTTitleText:SetText("Roll For Loot: Roll Tracker")
		frmRFLRTTitleText:SetPoint("TOP", frmRFLRollTracker, 0, -6)
		
		-- Build Loot Icon
		frmRFLRTLootIcon = CreateFrame("Button", "frmRFLLootIcon", frmRFLRollTracker, "ItemButtonTemplate")
		frmRFLRTLootIcon:SetPoint("TOPLEFT", 10, -30)
		textureRFLLootIconName = frmRFLRTLootIcon:CreateTexture("textureRFLLootIconName", "ARTWORK" , nil, nil )
		textureRFLLootIconName:SetTexture("Interface\\QUESTFRAME\\UI-QuestItemNameFrame") 
		textureRFLLootIconName:SetSize(130, 62)
		textureRFLLootIconName:SetPoint("LEFT", 30, 0)
		fsRFLLootIconName = frmRFLRTLootIcon:CreateFontString("fsRFLLootIconName", "ARTWORK" , "GameFontNormal")
		fsRFLLootIconName:SetPoint("LEFT", frmRFLRTLootIcon, "RIGHT", 8, 0)
		fsRFLLootIconName:SetSize(93, 38)
		fsRFLLootIconName:SetJustifyH("LEFT")
		
		-- Build Loot Roll Next Button
		RFLLootRoll_btnNext = CreateFrame("Button", "RFLLootRoll_btnNext", frmRFLRollTracker, "UIPanelButtonTemplate");
		RFLLootRoll_btnNext:SetPoint("TOPRIGHT", frmRFLRollTracker, -10, -30);
		RFLLootRoll_btnNext:SetWidth(100);
		RFLLootRoll_btnNext:SetText("Next");
		RFLLootRoll_btnNext:SetScript("OnEnter", function(self) RollForLoot:ButtonMouseOverTooltip(self) end)
		RFLLootRoll_btnNext:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
		RFLLootRoll_btnNext:SetScript("OnClick", function(self) RollForLoot:MoveToLootRoll("Next") end)
		
		-- Build Loot Roll Previous Button
		RFLLootRoll_btnPrev = CreateFrame("Button", "RFLLootRoll_btnPrev", frmRFLRollTracker, "UIPanelButtonTemplate");
		RFLLootRoll_btnPrev:SetPoint("RIGHT", RFLLootRoll_btnNext, -100, 0);
		RFLLootRoll_btnPrev:SetWidth(100);
		RFLLootRoll_btnPrev:SetText("Previous");
		RFLLootRoll_btnPrev:SetScript("OnEnter", function(self) RollForLoot:ButtonMouseOverTooltip(self) end)
		RFLLootRoll_btnPrev:SetScript("OnLeave", function(self) GameTooltip:Hide() end)
		RFLLootRoll_btnPrev:SetScript("OnClick", function(self) RollForLoot:MoveToLootRoll("Previous") end)
		
		-- Build Loot Scroll Frame
		local frmRFLRTScroll = CreateFrame("ScrollFrame", "frmRFLRTScroll", frmRFLRollTracker, "UIPanelScrollFrameTemplate")
		frmRFLRTScroll:SetWidth(frmRFLRollTracker:GetWidth() - 40);
		frmRFLRTScroll:SetHeight(frmRFLRollTracker:GetHeight() - 85);
		frmRFLRTScroll:SetPoint("TOPLEFT", 8, -75);
		
		-- Roll Background Frame
		local frmRFLRollTrackerBackground = CreateFrame("Frame", "frmRFLRollTrackerBackground", nil, nil );
		frmRFLRollTrackerBackground:SetPoint("TOPLEFT", 8, -75);
		frmRFLRollTrackerBackground:SetHeight(frmRFLRTScroll:GetHeight());
		frmRFLRollTrackerBackground:SetWidth(frmRFLRTScroll:GetWidth());
		frmRFLRollTrackerBackground:SetBackdrop({bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background-Dark",
			edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
			tile = true, tileSize = 16, edgeSize = 16,
			insets = {left = 1, right = 1, top = 1, bottom = 1}}
		);
		
		frmRFLRTScroll:SetScrollChild(frmRFLRollTrackerBackground);
		
		-- Loot Rool Header Font Strings
		fsRFL_RT_PlayerName = frmRFLRollTrackerBackground:CreateFontString("fsRFL_RT_PlayerName", "ARTWORK" , "GameFontNormalSmall")
		fsRFL_RT_PlayerName:SetPoint("TOPLEFT", frmRFLRollTrackerBackground, "TOPLEFT", 10, -5)
		fsRFL_RT_PlayerName:SetSize(125, 15)
		fsRFL_RT_PlayerName:SetJustifyH("LEFT")
		fsRFL_RT_PlayerName:SetText("Player Name")
		
		fsRFL_RT_RollValue = frmRFLRollTrackerBackground:CreateFontString("fsRFL_RT_RollValue", "ARTWORK" , "GameFontNormalSmall")
		fsRFL_RT_RollValue:SetPoint("LEFT", fsRFL_RT_PlayerName, "RIGHT", 0, 0)
		fsRFL_RT_RollValue:SetSize(50, 15)
		fsRFL_RT_RollValue:SetJustifyH("LEFT")
		fsRFL_RT_RollValue:SetText("Roll")
		
		fsRFL_RT_RollSpec = frmRFLRollTrackerBackground:CreateFontString("fsRFL_RT_RollSpec", "ARTWORK" , "GameFontNormalSmall")
		fsRFL_RT_RollSpec:SetPoint("LEFT", fsRFL_RT_RollValue, "RIGHT", 0, 0)
		fsRFL_RT_RollSpec:SetSize(50, 15)
		fsRFL_RT_RollSpec:SetJustifyH("LEFT")
		fsRFL_RT_RollSpec:SetText("Spec")
		
		fsRFL_RT_RollType = frmRFLRollTrackerBackground:CreateFontString("fsRFL_RT_Rol`lType", "ARTWORK" , "GameFontNormalSmall")
		fsRFL_RT_RollType:SetPoint("LEFT", fsRFL_RT_RollSpec, "RIGHT", 0, 0)
		fsRFL_RT_RollType:SetSize(75, 15)
		fsRFL_RT_RollType:SetJustifyH("LEFT")
		fsRFL_RT_RollType:SetText("Type")
		
		fsRFL_RT_RollItemsRcv = frmRFLRollTrackerBackground:CreateFontString("fsRFL_RT_RollItemsRcv", "ARTWORK" , "GameFontNormalSmall")
		fsRFL_RT_RollItemsRcv:SetPoint("LEFT", fsRFL_RT_RollType, "RIGHT", 0, 0)
		fsRFL_RT_RollItemsRcv:SetSize(100, 15)
		fsRFL_RT_RollItemsRcv:SetJustifyH("LEFT")
		fsRFL_RT_RollItemsRcv:SetText("Items Received")
	end
	
	frmRFLRollTracker:Hide();
end

function RollForLoot:ClearRTHistory()
	RFLLootRollIdxByIndex = nil;
	RFLLootRollIdxByValue = nil;
	RFLLootRolls = nil;
	DisplayedRTID = 0;
end

function RollForLoot:ClearRollToRTFrames()
	if frmRFLRollTrackerBackground == nil then
		return;
	end
	
	local kids = { frmRFLRollTrackerBackground:GetChildren() };
	
	for _, child in ipairs(kids) do
		if string.find(child:GetName(), "frmRFL_RT_Player") ~= nil  then
			child:Hide()
		end
	end
	
end

function RollForLoot:AddRollToRTFrame(i, playerName, rollValue, rollSpec, rollType)
		local frmRFL_RT_Player_i = _G["frmRFL_RT_Player" .. i];
		local fsRFL_RT_PlayerName_i;
		local fsRFL_RT_PlayerRoll_i;
		local fsRFL_RT_RollSpec_i;
		local fsRFL_RT_RollType_i;
		local fsRFL_RT_RollItemsRcv_i;
		
		if frmRFL_RT_Player_i == nil then
			frmRFL_RT_Player_i = CreateFrame("Frame", "frmRFL_RT_Player" .. i, frmRFLRollTrackerBackground, nil);
			frmRFL_RT_Player_i:SetPoint("TOPLEFT", 10, -20*(i-1)-20);
			frmRFL_RT_Player_i:SetHeight(20);
			frmRFL_RT_Player_i:SetWidth(frmRFLRTScroll:GetWidth());
			frmRFL_RT_Player_i:EnableMouse(true);
			
			if (RollForLoot:isMasterLooter()) or RFLDEBUG  then -- only allow loot assignment click if you are the master looter
				frmRFL_RT_Player_i:SetScript("OnMouseDown", function(self,button) RollForLoot:AssignLoot(self) end);
			end
			
			fsRFL_RT_PlayerName_i = frmRFL_RT_Player_i:CreateFontString("fsRFL_RT_PlayerName" .. i, "ARTWORK" , "GameFontWhiteSmall")
			fsRFL_RT_PlayerName_i:SetPoint("LEFT", frmRFL_RT_Player_i, "LEFT", 0, 0)
			fsRFL_RT_PlayerName_i:SetSize(125, 15)
			fsRFL_RT_PlayerName_i:SetJustifyH("LEFT")
			
			fsRFL_RT_PlayerRoll_i = frmRFL_RT_Player_i:CreateFontString("fsRFL_RT_PlayerRoll" .. i, "ARTWORK" , "GameFontWhiteSmall")
			fsRFL_RT_PlayerRoll_i:SetPoint("LEFT", fsRFL_RT_PlayerName_i, "RIGHT", 0, 0)
			fsRFL_RT_PlayerRoll_i:SetSize(50, 15)
			fsRFL_RT_PlayerRoll_i:SetJustifyH("LEFT")
			
			fsRFL_RT_RollSpec_i = frmRFL_RT_Player_i:CreateFontString("fsRFL_RT_RollSpec" .. i, "ARTWORK" , "GameFontWhiteSmall")
			fsRFL_RT_RollSpec_i:SetPoint("LEFT", fsRFL_RT_PlayerRoll_i, "RIGHT", 0, 0)
			fsRFL_RT_RollSpec_i:SetSize(50, 15)
			fsRFL_RT_RollSpec_i:SetJustifyH("LEFT")
			fsRFL_RT_RollSpec_i:SetText("Main")
			
			fsRFL_RT_RollType_i = frmRFL_RT_Player_i:CreateFontString("fsRFL_RT_RollType" .. i, "ARTWORK" , "GameFontWhiteSmall")
			fsRFL_RT_RollType_i:SetPoint("LEFT", fsRFL_RT_RollSpec_i, "RIGHT", 0, 0)
			fsRFL_RT_RollType_i:SetSize(75, 15)
			fsRFL_RT_RollType_i:SetJustifyH("LEFT")
			fsRFL_RT_RollType_i:SetText("BIS")
			
			fsRFL_RT_RollItemsRcv_i = frmRFL_RT_Player_i:CreateFontString("fsRFL_RT_RollItemsRcv" .. i, "ARTWORK" , "GameFontWhiteSmall")
			fsRFL_RT_RollItemsRcv_i:SetPoint("LEFT", fsRFL_RT_RollType_i, "RIGHT", 0, 0)
			fsRFL_RT_RollItemsRcv_i:SetSize(100, 15)
			fsRFL_RT_RollItemsRcv_i:SetJustifyH("LEFT")
			fsRFL_RT_RollItemsRcv_i:SetText("MS[2] / OS[3]")
		else
			fsRFL_RT_PlayerName_i = _G["fsRFL_RT_PlayerName" .. i];
			fsRFL_RT_PlayerRoll_i = _G["fsRFL_RT_PlayerRoll" .. i];
			fsRFL_RT_RollSpec_i = _G["fsRFL_RT_RollSpec" .. i];
			fsRFL_RT_RollType_i = _G["fsRFL_RT_RollType" .. i];
			fsRFL_RT_RollItemsRcv_i = _G["fsRFL_RT_RollItemsRcv" .. i];
		end
		
		fsRFL_RT_PlayerName_i:SetText(playerName);
		
		local color = RAID_CLASS_COLORS[RFLRaidRoster[RollForLoot:getRaidIndex(playerName)]["fileName"]]
		fsRFL_RT_PlayerName_i:SetTextColor(color.r, color.g, color.b, 1)
		
		fsRFL_RT_PlayerRoll_i:SetText(rollValue);
		fsRFL_RT_RollSpec_i:SetText(rollSpec);
		fsRFL_RT_RollType_i:SetText(rollType);
		frmRFL_RT_Player_i:Show();
end

-- Move to Loot Roll
function RollForLoot:MoveToLootRoll(cmd)
	--RollForLoot:Print("MoveToLootRoll: " .. cmd)
	
	if cmd == "Next" then
		RollForLoot:DisplayLootRoll(DisplayedRTID + 1);
	elseif cmd == "Previous" and DisplayedRTID > 1 then
		RollForLoot:DisplayLootRoll(DisplayedRTID - 1);
	end
end

function RollForLoot:GetLastRollIndex()
	local currentIndex = 0;
	if (not(RFLLootRollIdxByIndex == nil)) then
		currentIndex = table.getn(RFLLootRollIdxByIndex);
	end 
	
	if currentIndex == nil then
		--RollForLoot:Print("currentIndex was nil")
		currentIndex = 0;
	end
	
	return currentIndex;
end

function RollForLoot:CalculateLootRoll(message, sender)
	if RollForLoot:isMasterLooter() then
		message["RollVal"] = random(100);
		message["Player"] = sender;
	end

	return message
end

function RollForLoot:AddLootRoll(LootID, RFLRoll)
	--RollForLoot:Print("AddLootRoll ID: " .. LootID);
	
	if frmRFLRollTracker == nil then
		RollForLoot:BuildRollTrackerFrame();
	end
	
	if RFLLootRolls == nil then
		RFLLootRolls = {};
	end
	
	if RFLLootRollIdxByIndex == nil or RFLLootRollIdxByValue == nil then
		RFLLootRollIdxByIndex = {};
		RFLLootRollIdxByValue = {};
	end 
	
	if RFLLootRolls == nil then
		RFLLootRolls = {}
	end
	--RollForLoot:Print(LootID);
	--RollForLoot:Print(RFLRoll[LootID]);
	if RFLLootRollIdxByValue[LootID] == nil then
		local LastIdx = RollForLoot:GetLastRollIndex() + 1;
		
		--RollForLoot:Print("LastIdx" .. LastIdx);
		
		RFLLootRollIdxByIndex[LastIdx] = LootID;
		RFLLootRollIdxByValue[LootID] = LastIdx;
		
		--RollForLoot:Print("LastIdx" .. RFLLootRollIdxByIndex[LastIdx]);
	end
	
	if RFLLootRolls[LootID] == nil then
		RFLLootRolls[LootID] = {};
	end
	
	local noOfRolls = table.getn(RFLLootRolls[LootID])
	if (noOfRolls == nil) then
		noOfRolls = 0
	end
	
	RFLLootRolls[LootID][noOfRolls+1] = {};
	RFLLootRolls[LootID][noOfRolls+1]["RollVal"] = RFLRoll["RollVal"];
	RFLLootRolls[LootID][noOfRolls+1]["Player"] = RFLRoll["Player"];
	RFLLootRolls[LootID][noOfRolls+1]["RollSpec"] = RFLRoll["RollSpec"];
	RFLLootRolls[LootID][noOfRolls+1]["RollType"] = RFLRoll["RollType"];
end

function RollForLoot:DisplayLootRoll(RollNo)
	if RFLSettings["DisplayRT"] == true then
		if RFLLootRollIdxByIndex == nil then -- No Rolls yet!
			RollForLoot:Print("No loot has rolled on yet!");
			return;
		end
		-- Only Update Displayed if the roll set exisits.
		if RFLLootRollIdxByIndex[RollNo] ~= nil then
			DisplayedRTID = RollNo;
		end
		
		local lootID = RFLLootRollIdxByIndex[DisplayedRTID];	
		local LootItem = RFL_LootRollHistory[lootID]["Item"];
		local LootTexture = RFL_LootRollHistory[lootID]["Texture"];
		local LootQuality = RFL_LootRollHistory[lootID]["Quality"];
		
		-- Set Font Icon
		_G["frmRFLLootIcon"].icon:SetTexture(RFL_LootRollHistory[lootID]["Texture"]);
		
		-- Set font color of the item name to match the quality
		local redComponent, greenComponent, blueComponent = GetItemQualityColor(RFL_LootRollHistory[lootID]["Quality"])
		_G["fsRFLLootIconName"]:SetText(RFL_LootRollHistory[lootID]["Item"]);
		_G["fsRFLLootIconName"]:SetTextColor(redComponent, greenComponent, blueComponent, 1)
		
		_G["frmRFLLootIcon"]:SetScript("OnEnter", function(self) RollForLoot:RTHyperlinkToolTip(self) end)
		_G["frmRFLLootIcon"]:SetScript("OnLeave", function() GameTooltip:Hide() end)
		
		-- Hide Previous Roll Frames
		RollForLoot:ClearRollToRTFrames();
		
		-- Sort Table
		
		if RFLSettings["SortRollType"] == "SpecType" then
			table.sort(RFLLootRolls[lootID], SortBySpecType); -- sort by spec, type and roll
		else
			table.sort(RFLLootRolls[lootID], RFLSortBySpec); -- sort by spec and roll
		end
		
		-- Display All Received Rolls
		for i, roll in ipairs (RFLLootRolls[lootID]) do
			RollForLoot:AddRollToRTFrame(i, roll["Player"], roll["RollVal"], roll["RollSpec"], roll["RollType"])
		end
		
		frmRFLRollTracker:Show()
	else
		--RollForLoot:Print("Don't Display Loot Rolls: " .. DisplayedRTID);
		frmRFLRollTracker:Hide()
	end
end

local RollTrackerRefreshTime = 0;

function RollForLoot:RefreshRollTracker(self,elapsed)
    RollTrackerRefreshTime = RollTrackerRefreshTime + elapsed;
    if RollTrackerRefreshTime >= 2 then
        if frmRFLRollTracker:IsShown() then
			RollForLoot:DisplayLootRoll(DisplayedRTID)
		end
		RollTrackerRefreshTime = 0
    end
end

function RollForLoot:RTHyperlinkToolTip(self)
	local lootID = RFLLootRollIdxByIndex[DisplayedRTID];
	local LootLink = RFL_LootRollHistory[lootID]["Hyperlink"];
	
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
	GameTooltip:SetHyperlink(LootLink);
end

function RollForLoot:AssignLoot(self)
		
	if RollForLoot:isMasterLooter() then
	
		local playerName = _G["fsRFL_RT_PlayerName" .. string.sub(self:GetName(), -1)]:GetText();
		local rollSpec = _G["fsRFL_RT_RollSpec" .. string.sub(self:GetName(), -1)]:GetText();
		local raidIndex = RollForLoot:getRaidIndex(playerName);
		local lootSlot = RFL_LootRollHistory[RFLLootRollIdxByIndex[DisplayedRTID]]["LootSlot"];
		
		--RollForLoot:Print("Assign Loot: " .. playerName);
		--RollForLoot:Print("Raid Index: " .. raidIndex);
		--RollForLoot:Print("LootSlot: " .. lootSlot);
		
		candidate = GetMasterLootCandidate(lootSlot, raidIndex);
		--RollForLoot:Print("Loot Candidate: " .. tostring(candidate));
		
		if (candidate == playerName) then
			GiveMasterLoot(lootSlot, raidIndex)
		else -- search raid for the player
			local playerfound = false;
			for i = 1, GetNumGroupMembers() do
				if GetMasterLootCandidate(RFL_LootRollHistory[RFLLootRollIdxByIndex[DisplayedRTID]]["LootSlot"],i) == playerName then
					GiveMasterLoot(RFL_LootRollHistory[RFLLootRollIdxByIndex[DisplayedRTID]]["LootSlot"],i)
					playerfound = true;
					break;
				end
			end
			
			if not(playerfound) then
				RollForLoot:Print("Player is not elidgerable for loot");
			end
		end
		RollForLoot:SubmitLootAwardMessage(RFLLootRollIdxByIndex[DisplayedRTID], playerName, rollSpec)	
	end
end

function RollForLoot:UpdateLootAwards(lootID, playerName, rollSpec)
	--RollForLoot:Print("UpdateLootAwards");
end

-- Loot Roll Sort Funcitons
local SpecOrder = {};
SpecOrder["Main"] = 1;
SpecOrder["Off"] = 2;
SpecOrder["NA"] = 3;

local TypeOrder = {};
TypeOrder["2pc / 4pc"] = 1;
TypeOrder["BiS"] = 2;
TypeOrder["Major"] = 3;
TypeOrder["Minor"] = 4;
TypeOrder["Greed"] = 5;
TypeOrder["Pass"] = 6;

function RFLSortBySpec(lhs, rhs)
	if lhs["RollSpec"] ~= rhs["RollSpec"] then
		if SpecOrder[lhs["RollSpec"]] <= SpecOrder[rhs["RollSpec"]] then
			return true;
		else
			return false;
		end
	elseif lhs["RollVal"] >= rhs["RollVal"] then
		return true;
	end
end

function RollForLoot:SortBySpecType(lhs, rhs)
	if lhs["RollSpec"] ~= rhs["RollSpec"] then
		if SpecOrder[lhs["RollSpec"]] <= SpecOrder[rhs["RollSpec"]] then
			return true;
		else
			return false;
		end
	elseif lhs["RollType"] ~= rhs["RollType"] then
		if TypeOrder[lhs["RollType"]] <= TypeOrder[rhs["RollType"]] then
			return true;
		else
			return false;
		end
	elseif  lhs["RollVal"] >= rhs["RollVal"] then
		return true;
	end
end